package inria.meije.rc.sugarcubes;

public class Await extends InstructionImpl
{
    protected boolean ended = false;
    protected Config config;

    public Await(Config config){ this.config = config; }
    public Await(String event){ this(new PosConfig(event)); }

    public String toString(){ return "await "+config; }
    public Object clone(){
        Await inst = (Await)super.clone();
        inst.config = (Config)config.clone();
        return inst;
    }
    protected byte activation(Context context){ 
        if (ended) return TERM;
        if (!config.fixed((Domain)context)) return SUSP;
        if (!config.evaluate((Domain)context)) return STOP;
        ended = true;
        return ((Domain)context).isEndOfInstant() ? STOP : TERM;
    }
}
