package inria.meije.rc.sugarcubes;

public class Merge extends BinaryInstruction
{
    private byte leftStatus = SUSP, rightStatus = SUSP;

    public Merge (Instruction left, Instruction right){
        super.left = left;
        super.right = right;
    }

    public String toString(){ return "("+left+" || "+right+")"; }
    protected Instruction rest(){ 
        if (left.isTerminated()) return right.residual();
        if (right.isTerminated()) return left.residual();
        return new Merge(left.residual(),right.residual());
    }
    protected byte activation(Context context){
        if (leftStatus == SUSP) leftStatus = left.activ(context);
        if (rightStatus == SUSP) rightStatus = right.activ(context);
        if (leftStatus == TERM && rightStatus == TERM){ return TERM; }
        if (leftStatus == SUSP || rightStatus == SUSP){ return SUSP; }
        leftStatus = rightStatus = SUSP; 
        return STOP;
    }
    public void freeze(Context context){ 
        left.freeze(context); right.freeze(context); 
    }
    public void notifyTerminationToJava(Context context){
        left.notifyTerminationToJava(context);
        right.notifyTerminationToJava(context);
    }
    public void notifyWarmUpToJava(Context context){
        left.notifyWarmUpToJava(context);
        right.notifyWarmUpToJava(context);
    }
    public void notifyFreezeToJava(Context context){
        left.notifyFreezeToJava(context);
        right.notifyFreezeToJava(context);
    }
}
